﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace HierachicalBindingToCollection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }



        List<Record> l= new List<Record>();
        private void xdg_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Record r in xdg.SelectedItems.Records)
                l.Add(r);
        }
    }

    public class ContinentCollection : ObservableCollection<Continent>
    {
        public ContinentCollection()
        {
            Add(
                new Continent
                {
                    Name = "Africa",
                    Countres1 = new ObservableCollection<Country>()
                    {
                        new Country()
                        {
                            Name = "Algeria",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Algiers"},
                                new City {Name = "Oran"},
                            }
                        },
                        new Country()
                        {
                            Name = "Angola",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Soyo"},
                                new City {Name = "Ndalatando"},
                                new City {Name = "Ambriz"},
                            }
                        },
                        new Country()
                        {
                            Name = "Cape Verde",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Mindelo"},
                                new City {Name = "Assomada"},
                            }
                        }
                    }
                });

                Add(
                    new Continent
                    {
                        Name = "Asia",
                        Countres1 = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Cambodia",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Phnom Penh"},
                                                new City {Name = "Koh Kong"},
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "China",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Shanghai"},
                                                new City {Name = "Beijing"},
                                                new City {Name = "Tianjin"},
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Japan",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Tokyo"},
                                                new City {Name = "Yokohama"},
                                                new City {Name = "Sapporo"},
                                            }
                                        }
                                    }
                    });

            Add(new Continent
                {
                    Name = "Australia",
                    Countres1 = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Australia",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Sydney"},
                                                new City {Name = "Melbourne"},
                                                new City {Name = "Perth"},
                                            }
                                        }
                                    }
                });

            Add(new Continent
            {
                Name = "Europe",
                Countres1 = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Germany",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Berlin"},
                                                new City {Name = "Hamburg"}
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Italy",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Milan"},
                                                new City {Name = "Naples"},
                                                new City {Name = "Rome"}
                                            }
                                        }
                                    },
                                                    Countres2 = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Greece",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Kavala"}
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Bulgaria",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Sofia"}
                                            }
                                        }
                                    }
            });
        }
    }

    public class Continent
    {
        public string Name { get; set; }
        public ObservableCollection<Country> Countres1 { get; set; }
        public ObservableCollection<Country> Countres2 { get; set; }
    }

    public class Country
    {
        public string Name { get; set; }
        public ObservableCollection<City> Cities { get; set; }
    }

    public class City
    {
        public string Name { get; set; }
    }
}
